package org.cyrano.timetable.ui.edit;

import java.util.List;

import javax.swing.DefaultComboBoxModel;

import com.minotauro.cleda.util.LabelValueBean;

public class LabelValueBeanComboBoxModel<T> //
    extends
      DefaultComboBoxModel<LabelValueBean<T>> {

  // --------------------------------------------------------------------------------

  public void setSelectedData(T data) {
    for (int i = 0; i < getSize(); i++) {
      LabelValueBean<T> curLVB = getElementAt(i);

      if (data.equals(curLVB.getValue())) {
        setSelectedItem(curLVB);
        break;
      }
    }
  }

  // --------------------------------------------------------------------------------

  @SuppressWarnings("unchecked")
  public T/**/getSelectedData(/*  */) {
    LabelValueBean<T> curLVB = (LabelValueBean<T>) getSelectedItem();
    return curLVB.getValue();
  }

  // --------------------------------------------------------------------------------

  public void add(String label, T data) {
    addElement(new LabelValueBean<T>( //
        label, data));
  }

  // --------------------------------------------------------------------------------

  public void addAll(List<T> dataList, LabelGetter<T> labelGetter) {
    for (T data : dataList) {
      addElement(new LabelValueBean<T>( //
          labelGetter.getLabel(data), data));
    }
  }
}
