package org.cyrano.editor.parts;

import java.awt.Point;

public abstract class BaseViewPart implements ViewPart {

  private PartsRegister partsRegister;

  // --------------------------------------------------------------------------------

  public BaseViewPart(PartsRegister partsRegister) {
    this.partsRegister = partsRegister;
  }

  // --------------------------------------------------------------------------------

  @Override
  public PartsRegister getPartsRegister() {
    return partsRegister;
  }

  // --------------------------------------------------------------------------------

  @Override
  public ViewPart getViewPartAt(Point point) {
    return getRect().contains(point.x, point.y) ? this : null;
  }
}
